#!/bin/bash 
#
#
# iAM-Mix/iAM-Audio sysfs GPIO initialization script 
#
# This script is located in /etc and is called by rc.local 
#
#
# NOTE:  This directory (/sys/class/gpio/gpio55/)
#        is used to test to see if this script has run by rc.local
#        and/or rc.local.debug
#
#
# GPIO pin group
# --------------
# GPIO0  0-31
# GPIO1  32-63
# GPIO2  96-127
# GPIO3  128-159

################################
# Dolby CAT1100 
#
# CAT_RSTn     GPIO1_0  (32+0)
echo "      GPIO1_0"
echo 32  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio32/direction
echo 0   > /sys/class/gpio/gpio32/value
# CAT_AOKn     GPIO1_1  (32+1) 
echo "      GPIO1_1"
echo 33  > /sys/class/gpio/export
echo in > /sys/class/gpio/gpio33/direction
# CAT_UPGn     GPIO1_2  (32+2) 
echo "      GPIO1_2"
echo 34  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio34/direction
echo 0   > /sys/class/gpio/gpio34/value
# CAT_ERR0n    GPIO1_3  (32+3) 
echo "      GPIO1_3"
echo 35  > /sys/class/gpio/export
echo in > /sys/class/gpio/gpio35/direction
# CAT_ERR1n    GPIO1_4  (32+4) 
echo "      GPIO1_4"
echo 36  > /sys/class/gpio/export
echo in > /sys/class/gpio/gpio36/direction
# CAT_RUN      GPIO1_5  (32+5) 
echo "      GPIO1_5"
echo 37  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio37/direction
echo 0   > /sys/class/gpio/gpio37/value
# CAT_ASF0     GPIO1_29 (32+29) 
echo "      GPIO1_29"
echo 61  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio37/direction
echo 0   > /sys/class/gpio/gpio37/value
# CAT_ASF1     GPIO1_30 (32+30) 
echo "      GPIO1_30"
echo 62  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio37/direction
echo 0   > /sys/class/gpio/gpio37/value
# CAT_ASF2     GPIO1_31 (32+31) 
echo "      GPIO1_31"
echo 63  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio37/direction
echo 0   > /sys/class/gpio/gpio37/value
# CAT_OCS0     GPIO2_2  (64+2)
echo "      GPIO2_2"
echo 66  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio66/direction
echo 0   > /sys/class/gpio/gpio66/value
# CAT_OCS1     GPIO2_3  (64+3)
echo "      GPIO2_3"
echo 67  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio67/direction
echo 0   > /sys/class/gpio/gpio67/value
# CAT_OCS2     GPIO2_4  (64+4)
echo "      GPIO2_4"
echo 68  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio68/direction
echo 0   > /sys/class/gpio/gpio68/value

################################
#
# iAM-Mix FPGA/LCD SPI multiplexer control
# FPGA_LCDn    GPIO1_23  (32+23) 
#
echo "      GPIO1_23"
echo 55  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio55/direction
echo 0   > /sys/class/gpio/gpio55/value

################################
#
# AOIP Control
#
# AOIP_SPIB_FLOWCTL    GPIO1_23  (32+23) 
echo "      GPIO1_26"
echo 58  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio58/direction
echo 0   > /sys/class/gpio/gpio58/value
# AOIP_SPIB_FLOWCTL    GPIO1_23  (32+24) 
echo "      GPIO1_27"
echo 59  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio59/direction
echo 0   > /sys/class/gpio/gpio59/value

################################
#
# SPKR_RSTn  GPIO0_27 (0+27)
#
# Class D Amplifier I2C Reset
#
echo "      GPIO0_27"
echo 27  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio27/direction
echo 1   > /sys/class/gpio/gpio27/value

################################
#
# Front panel Page Switch 
# GPIO0_29 (0+29)
#
echo "      GPIO0_29"
echo 29  > /sys/class/gpio/export
echo in  > /sys/class/gpio/gpio29/direction

################################
#
# Front panel headphone detect
# GPIO1_17 (32+17)
#
echo "      GPIO1_17"
echo 49  > /sys/class/gpio/export
echo in  > /sys/class/gpio/gpio49/direction

################################
#
# MADI-8/16 Detect
# GPIO1_16 (32+16)
#
echo "      GPIO1_16"
echo 48  > /sys/class/gpio/export
echo in  > /sys/class/gpio/gpio48/direction

################################
#
# GPIO0_7
# Am335x to FPGA SPI1 Chipselect 
#
echo "      GPIO0_7"
echo 7   > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio7/direction
echo 1   > /sys/class/gpio/gpio7/value

################################
#
# GPIO0_26
# OLED On/Off
# TODO: Fails 
#echo "      GPIO0_26"
#echo 26  > /sys/class/gpio/export
#echo out > /sys/class/gpio/gpio26/direction
#echo 1   > /sys/class/gpio/gpio26/value

################################
#
# TOUCH INTn GPIO1_6 (32+6)
# This pin is defined as an IRQ and is not GPIO
#
#echo "      GPIO1_6"
#echo 26  > /sys/class/gpio/export
#echo in  > /sys/class/gpio/gpio38/direction

################################
#
# TOUCH LCD_PWM & LCD_RSTn
#
echo "      GPIO1_19"
echo 51  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio51/direction
echo 1   > /sys/class/gpio/gpio51/value

echo "      GPIO1_20"
echo 52  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio52/direction
echo 1   > /sys/class/gpio/gpio52/value

################################
#
# LCD_MEMCLK 
# This pin must be asserted high to enable LCD raster mode
#
echo "      GPIO2_1"
echo 65  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio65/direction
echo 1   > /sys/class/gpio/gpio65/value

################################
#
# TOUCH Reset GPIO1_7 (32+7)
#
echo "      GPIO1_7"
echo 39  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio39/direction
echo 1   > /sys/class/gpio/gpio39/value

################################
#
# OLED_ON   GPIO0_26 (0+26)
#
echo "      GPIO0_26"
echo 26  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio26/direction
echo 1   > /sys/class/gpio/gpio26/value

################################
#
# POT_AB_SEL  GPIO1_13 (32+13)
# Sets potentiometer group select to bank 0 (channel pots 9-16)
#
echo "      GPIO1_13"
echo 45  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio45/direction
echo 1   > /sys/class/gpio/gpio45/value

################################
#
# GPIO3_21 : Brown_OutN
# 96 + 21
# Power loss (BrownOut) detection
#
echo "      GPIO3_21"
echo 117  > /sys/class/gpio/export
echo in   > /sys/class/gpio/gpio117/direction
echo 1    > /sys/class/gpio/gpio117/active_low
echo both > /sys/class/gpio/gpio117/edge

################################
#
# FPGA Quad SPI Flash Program control
#
# This is used to enable SPI access to Quad  SPI flash on iAM Mainboard
echo "      GPIO1_28"
echo 60  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio60/direction
echo 1 > /sys/class/gpio/gpio60/value

#
# This must be an input for iAM LCD frontpanel
# It is used to determine display position (center/right) 
#echo "      GPIO1_28"
#echo 60  > /sys/class/gpio/export
#echo in > /sys/class/gpio/gpio60/direction

echo "      GPIO1_22"
echo 54  > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio54/direction
echo 1 > /sys/class/gpio/gpio54/value
#
# GPIO1_12 FPGA Prog_n (32+12)
#
echo "      GPIO1_12"
echo 44  > /sys/class/gpio/export
#echo 1   > /sys/class/gpio/gpio44/value
#echo out > /sys/class/gpio/gpio44/direction

#
# GPIO3_19 FPGA INIT_n (96+19)
#
echo "      GPIO3_19"
echo 115 > /sys/class/gpio/export
echo in  > /sys/class/gpio/gpio115/direction
#
# GPIO1_18 FPGA Config_Done_n (32+18)
#
echo "      GPIO1_18"
echo 50 > /sys/class/gpio/export
echo in  > /sys/class/gpio/gpio50/direction

############
#  Moving python c libraries for web
############

SRC_PATH="/root/iam_sysapp/iam_binfiles/"
TARGET_PATH="/root/iam_sysapp/iam_audio_ui/"

#TODO: When juan ready, get rid of some of these. 
file_names="pyeeprom.so pyplugin.so iambeacon.so pyversion.so"
for file_name in $file_names
do
    src_file=$SRC_PATH$file_name
    if [ -f "$src_file" ]
    then
        mv $src_file  $TARGET_PATH
        echo "$src_file was moved successfully."
    fi
done

file_name="pyQspiPgm.so"
src_file=$SRC_PATH$file_name
if [ -f "$src_file" ]
then
    cp -p $src_file  $TARGET_PATH
    echo "$src_file was copied successfully."
fi


############
#  Copying  Database to memory
############

DB_SHM_MEM_PATH="/run/shm/database"
DB_PATH="/root/iam_sysapp/iam_audio_ui/"

if [ ! -d "$DB_SHM_MEM_PATH" ]
then
    mkdir $DB_SHM_MEM_PATH
fi

if [ -f "$DB_PATH/database/wohler_audio.db" ]
then
    cp -p $DB_PATH/database/wohler_audio.db $DB_SHM_MEM_PATH/.
fi

