import json
import requests
import logging
from metersConstants import URL_METER_APP

logger = logging.getLogger("__meters_api__")

#
# Functions listed below use SocketIO
#


def meter_data(json_message_req):
    """
     Setting Meter  Data
     :param json_message_req:	Meter Data
     :return
    """
    url = "{base_url}{meter_data_end_point}".format(base_url=URL_METER_APP,
                                                    meter_data_end_point="/api/v1/meter-data")
    meter_data_json = json.dumps(json_message_req)
    headers = {'content-type': 'application/json'}
    try:
        logger.debug("sending : %s", str(meter_data_json))
        response = requests.put(url, data=meter_data_json, headers=headers)
    except requests.ConnectionError:
        logger.debug("Trying to connect to Meters App ...")
    except Exception as e:
        logger.exception("meter_data().Error :" + str(e).replace('"', ''))
