import logging
# import subprocess
# import common_util
import models
# import constants
# from flask_login import login_required, login_user, current_user, logout_user
from flask import (Blueprint,
                   render_template
                   )
from common.users import logged_in_user
from forms import NetworkSetupForm
from product_config import product_info
import json
# from config import db

logger = logging.getLogger("__meters_sub__")
logger.setLevel(logging.DEBUG)

#
# Register Flask Blueprint
#
meters = Blueprint('meters',
                   __name__,
                   url_prefix='/meters',
                   template_folder='templates'
                   )


@meters.route('/meters', methods=['GET', 'POST'])
def root():
    user = logged_in_user()
    netform = NetworkSetupForm()
    preset_name = "Preset 1"
    try:
        preset_data = json.load(open('/root/iam_sysapp/iam_audio_ui/database/active_preset.json'))
        preset_obj = models.Preset.get_by_id(preset_data["PresetId"])
        preset_name = preset_obj.Name if preset_obj else preset_name
    except Exception:
        pass

    label_meters = ["Input-" + str(idx) for idx in range(1, 17)]
    return render_template('/meters/remote_meters.htm',
                           user=user,
                           form=netform,
                           product_name=product_info.PRODUCT_NAME,
                           preset_name=preset_name,
                           preset_labels=label_meters,
                           )


@meters.route('/loudness', methods=['GET', 'POST'])
def loudness_meters():
    user = logged_in_user()
    netform = NetworkSetupForm()
    preset_name = "Preset 1"
    try:
        preset_data = json.load(open('/root/iam_sysapp/iam_audio_ui/database/active_preset.json'))
        preset_obj = models.Preset.get_by_id(preset_data["PresetId"])
        preset_name = preset_obj.Name if preset_obj else preset_name
    except Exception:
        pass

    label_meters = ["Input-" + str(idx) for idx in range(1, 17)]
    return render_template('/meters/loudness_meters.htm',
                           user=user,
                           form=netform,
                           product_name=product_info.PRODUCT_NAME,
                           preset_name=preset_name,
                           preset_labels=label_meters,
                           )
