from flask_login import current_user

#
# Helper Functions
#
#

def is_authenticated():
    try:
       # Try using old flask-login method (is_authenticated is a function)
       return current_user.is_authenticated()
    except TypeError: 
       # New version of flask-login: is_authenticated is a property
       return current_user.is_authenticated


def logged_in_user():
    from models import User
    if is_authenticated():
        return current_user
    return User.query.filter_by(username='administrator').first()
