import json
import re
import os, sys, subprocess
# import pyversion
import logging
from shutil import copyfile
from time import sleep

logger = logging.getLogger(__name__)
#
# Helper Functions
#

"""
    TRUTHY_VALUES is a map of string values that map to boolean True.
    Used in string_to_bool().
"""
TRUTHY_VALUES = (
    'y',
    'yes',
    'true',
    't',
    '1'
)


def iAMeeprom_good_to_go_tmp() :
    return 1

def get_unit_options(file_name, file_path):
    clean_options=[]
    options = []
    try:
        with open(file_path + file_name) as f:
            options = f.read()
    except Exception as ex:
        print('ERROR : Open  ' + file_path + file_name + " Error: "  + str (ex) )

    logger.debug("file_name=%s, file_path=%s: options=%s", file_name, file_path, options)
    if options:
        clean_options = options.splitlines()
    logger.debug("clean_options=%s", clean_options)
    return clean_options


def json_dump(obj, path):
    try:
        if obj is not None and path is not None:
            directory,filename = os.path.split(path)
            if not os.path.exists(directory):
                os.makedirs(directory)
            with open (path,'w+') as fp:
               json.dump(obj,  fp, separators=(',', ':'))
               return True

        return False
    except Exception as ex:
        logger.debug("ERROR : json_dump " + path + ". Exception : " + str (ex) )
        return False

def json_load(path):
    try:
        if path is not None:
            data = None
            with open (path) as fp:
               data = json.load(fp)
            return data
        else:
            return None
    except Exception as ex:
        logger.debug("ERROR : json_load " + path + ". Exception : " + str (ex) )
        return None
