from flask_wtf import Form
from wtforms.fields import StringField , IntegerField, PasswordField, BooleanField, SubmitField, TextField, SelectField, RadioField, SelectMultipleField
from wtforms.validators import DataRequired, url , IPAddress, NumberRange, Email, Length

class NetworkSetupForm(Form):
      network_ip_address = StringField('IP Address', validators=[DataRequired(), IPAddress()])
      mask_ip_address = StringField('IP Mask', validators=[DataRequired(), IPAddress(message="Enter a valid Ip Address XXX.XXX.XXX.XXX")] )
      gateway_ip_address = StringField('Gateway Address', validators=[DataRequired(), IPAddress()])
      multicast_ip_address = StringField('Dns-nameserver', validators=[DataRequired(), IPAddress()])


class LoginForm(Form):
      username = TextField('Email Address', validators=[DataRequired('Please provide a valid email address.'),
                                                        Email(message=(u'That\'s not a valid email address.'))])
      password = PasswordField('Password', validators=[DataRequired('Please provide a password.')])
      remember_me = BooleanField('Keep me logged in')
      submit = SubmitField('Log In')

