
$(document).ready(function(){
    // namespace
    namespace = '/metersData'; // change to an empty string to use the global namespace
    lu_namespace = '/luData';

    //connect to the socket server.
    var ppm_socket = io.connect('http://' + document.domain + ':' + location.port + namespace, {

      'sync disconnect on unload': true,
      reconnection: true,
      reconnectionDelay: 2000,
      reconnectionDelayMax : 10000,
      reconnectionAttempts: Infinity
    });
    var lu_socket = io.connect('http://' + document.domain + ':' + location.port + lu_namespace, {
      'sync disconnect on unload': true,
      reconnectionDelay: 2000,
      reconnectionDelayMax : 10000,
      reconnectionAttempts: Infinity
    });
     console.log("meters - ppm_socket");
     console.log(ppm_socket);
    var numbers_received = [];

    var meterDataQ = [];
    var prev_meter_info_count = -1;

    var meter_info_count ;
    var reload_required = false;


    var meterUpdateTimer = setInterval(meterUpdateTimerFxn, 100);

    function meterUpdateTimerFxn() {
      if(hasMinimize == true) {
          reload_required = true;
      } else if(reload_required == true) {
        clearInterval(meterUpdateTimer);
        location.reload();
      }
      if(meterDataQ.length > 0) {
        var meterData = meterDataQ[0];
        if(typeof meterData !== 'undefined') {
           if (hasMinimize == false) {
             update_meters(meterData);
           }
        }
        meterDataQ.shift();

      }


    }

    //receive details from server
    ppm_socket.on('newmetresdata', function(msg) {
         var data = msg.data || '{}'; // squelch console errors
         //console.log(typeof data);
         //console.log('newmetresdata msg="'+JSON.stringify(msg)+'" data="'+data+'"');
         if ((hasMinimize == false) && (reload_required === false)) {
             if (typeof data == "object" ) {
                 if(data.hasOwnProperty("meter_data") && (typeof data.meter_data == "object")) {
                     //console.log("M",Date.now());
                    //update_meters(data.meter_data);
                    //meterData = data.meter_data;
                    //console.log(meterDataQ.length);
                    meter_info_count = data.meter_data[3]["count"];
                    //meter_info_count = parseInt(meter_info_count)
                     if (prev_meter_info_count === -1) {
                       prev_meter_info_count = meter_info_count;
                     }

                     if (prev_meter_info_count !== meter_info_count) {

                        console.log(prev_meter_info_count, meter_info_count);
                           reload_required = true;
                            clearInterval(meterUpdateTimer);
                            prev_meter_info_count = meter_info_count;
                            location.reload();
                      } else {
                        //prev_meter_info_count = meter_info_count;
                        if(meterDataQ.length > 20) {
                            console.log("Flush Q!");
                            /*
                            for(let i = meterDataQ.length; (i > 18); i--) {
                              var meterData = meterDataQ[0];
                              if(typeof meterData !== 'undefined') {
                                 if (hasMinimize == false) {
                                   update_meters(meterData, 10);
                                 }
                              }
                              meterDataQ.shift();
                            }
                            */

                            meterDataQ = [];
                            console.log(meterDataQ.length);
                          }
                          // Meter data is not comming on 100 ms interval so putting it on Q
                          meterDataQ.push(data.meter_data);
                      }


                 }
             }
         }
    });


    ppm_socket.on( 'connect', function () {
      console.log( 'connected to server' );
      meterDataQ = [];
    } );
    ppm_socket.on( 'disconnect', function () {
      console.log( 'disconnected from server' );
      meterDataQ = [];
      //clearInterval(meterUpdateTimer);
      //location.reload();
    } );

    lu_socket.on('newludata', function(msg) {
         var data = msg.data || '{}'; // squelch console errors
         //console.log(typeof data);
         //console.log('newmetresdata msg="'+JSON.stringify(msg)+'" data="'+data+'"');
         if (hasMinimize == false) {
             if (typeof data == "object" ) {
               if(data.hasOwnProperty("lu_data") && (typeof data.lu_data == "object")) {
                   //console.log(data.lu_data);
                    //console.log("L",Date.now());
                    if(reload_required === false) {
                      update_lu(data.lu_data);
                    }

                 }
             }
         }
    });

    lu_socket.on( 'connect', function () {
      console.log( 'lu connected to server' );
    } );
    lu_socket.on( 'disconnect', function () {
      console.log( 'lu disconnected from server' );
      //reload_required = true;
      //clearInterval(meterUpdateTimer);
      //location.reload();
    } );



});
