from gevent import monkey
monkey.patch_all()
import logging
import os
from flask import (Flask, render_template, url_for, session, request,
                   redirect, flash, current_app)
from flask_socketio import SocketIO, emit
from models import User
from common.users import logged_in_user, is_authenticated
from config import app, login_manager
#from time import time

logging.basicConfig(level=os.environ.get('PYTHON_LOGLEVEL', 'INFO'))
logger = logging.getLogger(__name__)


#
# global and static variables
#

#
# Socket IO
#

socketio = SocketIO(app)


print "*** Meter App is ready ***"

#
# Helper Functions
#


@login_manager.user_loader
def load_user(userid):
    return User.query.get(int(userid))

# @app.before_request
# def before_request():
#     millis = int(round(time() * 1000))
#     print millis
#     print request.method, request.endpoint
#
#
# @app.after_request
# def after_request(resp):
#     millis = int(round(time() * 1000))
#     print 'Response @:: {} / {}'.format(millis, resp.status_code)
#     return resp

#
# Web routes
#


@app.route('/')
@app.route('/index')
def index():
    return render_template('index.htm')


if not app.debug:
    @app.errorhandler(404)
    def page_not_found(e):
        user = logged_in_user()
        # return render_template('404.htm', title="Page Not Found", user=User("Administrator", "Account") ), 404
        return render_template('404.htm', title="Page Not Found", user=user), 404


    @app.errorhandler(500)
    def server_error(e):
        user = logged_in_user()
        # return render_template('500.htm', title="Page Not Found", user=User("Administrator", "Account") ), 500
        return render_template('500.htm', title="Page Not Found", user=user), 500

connected_count = 0
@socketio.on('connect', namespace='/metersData')
def test_connect():
    global connected_count
    connected_count = connected_count + 1
    print('Meter Client connected')
    print "Meter clients {}".format(connected_count)

def test_reconnect():
    global connected_count
    connected_count = connected_count + 1
    print('Meter Client reconnected')
    print "Meter clients {}".format(connected_count)

@socketio.on('disconnect', namespace='/metersData')
def test_disconnect():
    global connected_count
    connected_count = connected_count - 1
    print "Meter clients {}!".format(connected_count)
    if connected_count < 0:
        connected_count = 0
    print('Meter Client disconnected')


lu_connected_count = 0
@socketio.on('connect', namespace='/luData')
def cl_connect():
    global lu_connected_count
    lu_connected_count = lu_connected_count + 1
    print('LU Client connected')
    print "LU clients {}".format(lu_connected_count)

@socketio.on('reconnect', namespace='/luData')
def cl_connect():
    global lu_connected_count
    lu_connected_count = lu_connected_count + 1
    print('LU Client reconnected')
    print "LU clients {}".format(lu_connected_count)

@socketio.on('disconnect', namespace='/luData')
def cl_disconnect():
    print('LU Client disconnected')
    global lu_connected_count
    lu_connected_count = lu_connected_count - 1
    print "LU clients {}!".format(lu_connected_count)
    if lu_connected_count < 0:
        lu_connected_count = 0



@socketio.on('hwmMetersDataEvent', namespace='/hwmMetersData')
def handle_hwmMetersData_event(jsondata):
    #print jsondata
    global connected_count
    if connected_count > 0:
        if "meter_data" in jsondata:
            socketio.emit('newmetresdata', {'data': jsondata}, namespace='/metersData')

    #pass


@socketio.on('hwmLuDataEvent', namespace='/hwmLuData')
def handle_hwmMetersData_event(jsondata):
    #print jsondata
    global lu_connected_count
    if lu_connected_count > 0:
        if "lu_data" in jsondata:
            socketio.emit('newludata', {'data': jsondata}, namespace='/luData')
    #pass


if __name__ == "__main__":
    socketio.run(app, host='0.0.0.0', port=5000)
