"""create SystemPreference table

Revision ID: 752c4af56c70
Revises: 3982e06eeb8c
Create Date: 2018-02-23 18:19:14.048200

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '752c4af56c70'
down_revision = '3982e06eeb8c'
branch_labels = None
depends_on = None




def create_table_SystemPreference():
    try:
        op.create_table('SystemPreference',
        sa.Column('id', sa.Integer(), primary_key=True, autoincrement=True),
        sa.Column('Data', sa.BLOB(), nullable=True),
        sa.Column('last_Updated_date', sa.DateTime(), nullable=False),
        sa.Column('last_Updated_by_user', sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(['last_Updated_by_user'], ['User.id'], ),
        sa.PrimaryKeyConstraint('id')
        )
        print "Created SystemPreference Table..."
    except:
        print "Table SystemPreference already exists."


def upgrade():
    create_table_SystemPreference()


def downgrade():
    op.drop_table('SystemPreference')
