var Modal = null;
if (typeof window !== 'undefined') {
  Modal = window.ReactModal;
}

const customStyles = {
  overlay : {
    position          : 'fixed',
    top               : 0,
    left              : 0,
    right             : 0,
    bottom            : 0,
    backgroundColor   : 'rgba(0,0,0, 0.5)'
  },
  content : {
    top                   : '30%',
    left                  : '50%',
    right                 : 'auto',
    bottom                : 'auto',
    marginRight           : '-50%',
    transform             : 'translate(-50%, -50%)',
    backgroundColor       : 'rgba(0,0,0, 0.5)'
  }
};

var LogPanel = React.createClass({
    getInitialState: function () {
        return {
            text: ""
        }
    },

    appendLine: function (line) {
        var separator = this.state.text.length ? "\n" : "";
        this.setState({
            text: this.state.text + separator + new Date().toLocaleTimeString() + " >> "+ line
        }, function () {
            // Force scroll to bottom
            // http://stackoverflow.com/a/26557626/1309774
            this.refs.logText.scrollTop = this.refs.logText.scrollHeight;
        });
    },
    render: function () {
        return (
            <textarea
                ref="logText"
                style={{width: '100%', resize: 'none'}}
                disabled="true"
                readOnly="true"
                rows="10"
                value={this.state.text}
                ></textarea>
        )

   }
});


var RemoteUpdatesProgressDialog = React.createClass({
    __buttonTextForState: function () {
        //var stateTextMap = {
        //    'idle'      : 'Start',
        //    'running'   : 'Cancel',
        //    'complete'  : 'Close'
        //}
        // return stateTextMap[this.props.runState]
        return 'Close';
    },

    appendLogLine: function (line) {
        if (this.refs.logPanel) {
            this.refs.logPanel.appendLine(line);
        } else {
            this.logger.warn("logPanel undefined, so won't add '"
                + line + "' to panel");
        }
    },

    getInitialState: function () {
        return {
            isOpen: false,
        }
    },

    logger: Logger.get('RemoteUpdatesProgressDialog'),

    open: function () {
        this.setState({
            isOpen:true,
        }, function () {
            // After open state is set completes...
        });
    },

    __handleClose: function () {
        // TODO: When should we allow close?
        // Only after running completes
        if (this.props.onClose()) {
            if (!this.state.running) {
                this.setState({isOpen: false}, function () {
                    this.props.onClose && this.props.onClose();
                });
            }

        }
    },

    propTypes: {
        file: React.PropTypes.object,
        totalItems: React.PropTypes.number,
        progress: React.PropTypes.shape({
            currentTarget: React.PropTypes.string,
            currentStatus: React.PropTypes.string,
            currentItemNumber: React.PropTypes.number
        })
    },

    render: function () {
        return (
            <Modal
                className="modal-dialog"
                isOpen={this.state.isOpen}
                onRequestClose={this.__handleClose}
                style={customStyles}>
                <div className="modal-content">
                    <div className="modal-header">
                      <button type="button" className="close" onClick={this.__handleClose}>
                        <span aria-hidden="true">&times;</span>
                        <span className="sr-only">Close</span>
                      </button>
                      <h4 className="modal-title">Firmware Updates</h4>
                    </div>
                    <div className="modal-body">
                        <div>File: {this.props.file ? this.props.file.filename : null}</div>
                        <div>Current Target: {this.props.progress.currentTarget}</div>
                        <div>Current Status: {this.props.progress.currentStatus}</div>
                        { this.props.totalItems && this.props.progress.currentItemNumber > 0 ?
                            <div>Updating target {this.props.progress.currentItemNumber} of {this.props.totalItems}</div>
                                : null }

                        <div>Process log:</div>
                        <LogPanel ref="logPanel" />
                    </div>
                    <div className="modal-footer">
                      <button type="button"
                              disabled={this.props.runState !== 'idle'}
                              className="btn btn-default"
                              onClick={this.__handleClose}>
                          {this.__buttonTextForState()}
                          {/* this.props.runstate !== 'idle' ?
                          <img src="/static/images/spinner-blue-large.gif"
                               height="24px"
                               width="24px"
                               /> : null */}

                        </button>
                    </div>
                </div> {/* .modal-content */}
            </Modal>

        )
    }
});



// Make components available on the global namespace.
if (typeof window != 'undefined') {
    window.RemoteUpdatesProgressDialog = RemoteUpdatesProgressDialog;
}

