
/**
  * Local firmware updates.  Render a list of available firmware updates.
  */

var FirmwareUpdatesWidget = React.createClass({
    getInitialState: function () {
        return {files: []}
    },
    getAvailableUpdates: function() {
    // Reset state
    this.setState({
        scan: {
            scanning: true,
        },
        lastError: null
    }, function () {
        $.ajax({
          url: this.props.url,
          dataType: 'json',
          cache: false,
          success: function(data) {
            this.setState({
                files: data.result.files,
                scan: {
                    scanning: false
                }
            }, function () {console.log(this.state);});
          }.bind(this),
          error: function(xhr, status, err) {
            // xhr.readyState == 0 means connection error, CORS blocked, etc.
            // xhr.readyState == 4 means HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            // ref http://stackoverflow.com/a/28404728
            console.error(this.props.scanUrl, status, err.toString());
            // TODO: pop an error message
            this.setState({
                scan: {
                    scanning: false,
                    // TODO: store actual error codes from xhr.status if possible.
                    lastError: status
                }
            });
          }.bind(this)
        });
      });
    },
    componentDidMount: function () {
      this.getAvailableUpdates();
    },
    render: function () {
        return (
            <div id="firmware-update-widget" className="container-fluid">
                {/* this.props.url */}
                { this.state.files.length ?
                    <div>
                        <h3>Available firmware updates</h3>
                        <FirmwareUpdatesList fileInfoList={this.state.files} />
                    </div>
                    : <div>
                        No firmware updates detected.  Insert a thumb drive containing firmware updates.
                      </div>
                }
            </div>
        )
    }
});

var FirmwareUpdatesList = React.createClass({
    render: function () {
         var updateNodes = this.props.fileInfoList.map(function (fileInfo) {
            return (
                <FirmwareUpdateEntry packageInfo={fileInfo} />
                );
        }, this);
        return (
            <div>{updateNodes}
            </div>
        )
    }
});

var FirmwareUpdateEntry = React.createClass({
    render: function () {
        return (
            <div>
                <button>Apply</button> Description: {this.props.packageInfo.metadata.description} Version: {this.props.packageInfo.metadata.version}
            </div>
        )
    }
});

var updatesbox = ReactDOM.render(
    <div>
        <FirmwareUpdatesWidget url={DiscoveryConfig.urls.fwGetUpdates}/>
    </div>,
    document.getElementById('updatesBox')
);
